/*
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "func.h"

function lpre[MAX_FUNCTIONS_ALPHABET] = {
	{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},// A, B
	{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},// C, D
	{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},// A, F
	{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},// G, H
	{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},// I, J
	{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},// K, L
	{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},// M, N
	{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},// O, P
	{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},// Q, R
	{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},// S, T
	{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},// U, V
	{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},// W, X
	{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL} // Y, Z
	} ;
function fpre[MAX_FUNCTIONS] = {
	{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},
	{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},
	{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},
	{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},
	{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},
	{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},
	{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},
	{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL},{DEFAULT_TYPE,DEFAULT_VAL,NULL,NULL}
	} ;

double old_ans =0.0 ;
int error_value ;



static char* opUnaires [] = {
	"-",
	"+",
	"sqrt",
	"sqr",
	"abs",
	"exp",
	"ln",
	"log",
	"sin",
	"cos",
	"tan",
	"arcsin",
	"arccos",
	"arctan",
	"round",
	"sh",
	"ch",
	"th",
	"argsh",
	"argch",
	"argth",
	"floor",
	"ceil",
	"fact",
	"frac"
	} ;


void initialise_f( function* f)
{
 f->type = DEFAULT_TYPE ;
 f->val = DEFAULT_VAL ;
 f->left = NULL ;
 f->right = NULL ;
}

int constructor_f( function* f)
{
 f = (function*) malloc(sizeof(function)) ;
 if (f==NULL) return 1 ;
	else
	{
	 initialise_f( f) ;
	 return 0 ;
	}
}


void destroy( function* f)
{
 switch( (f->type) & CACHE )
	{
	case 2 : if ( f->left != NULL )
			{
			 destroy( f->left ) ;
			 free( f->left ) ;
			}
		 break ;
	case 3 : if ( f->left != NULL )
			{
			 destroy( f->left ) ;
			 free( f->left ) ;
			}
		 if ( f->right != NULL )
			{
			 destroy( f->right ) ;
			 free( f->right ) ;
			}
		 break ;
	default : ;
	}
}


int verifyLoop( function* f , function* compar )
{
 unsigned long ty = f->type ;

 switch( ty & CACHE )
	{
	 case 0 : case 1 : return 0 ;
	 case 2 : return verifyLoop(f->left,compar)  ;
	 case 3 : return verifyLoop(f->left,compar) | verifyLoop(f->right,compar)  ;
	 case 4 : if (f->left==compar) return 1 ;
	 	  if (f->right!=NULL) return verifyLoop(f->left,compar) | verifyLoop(f->right,compar)  ;
			else return verifyLoop(f->left,compar) ;
	 default : return 2 ;
	}
}


void destroy_f( function* f )
{
 destroy( f ) ;
 f->type = DEFAULT_TYPE ;
 f->val = DEFAULT_VAL ;
 f->left = NULL ;
 f->right = NULL ;
}


void copy_f( function* b, function* a )
// b <- a
// copie complete
{
 function* aux ;
 function* aux2 ;
 unsigned long t = a->type ;

 destroy_f( b ) ;
 b->type = t ;
 b->val  = a->val ;

 switch( t & CACHE )
	{
	case 0 : case 1 : ; break ;
	case 2 : b->right = NULL ;
		 aux = malloc(sizeof(function)) ;
		 b->left = aux ;
		 copy_f( b->left,a->left ) ;
		 break ;
	case 3  : aux  = malloc(sizeof(function)) ;
		  aux2 = malloc(sizeof(function)) ;
		  b->left = aux ;
		  b->right = aux2 ;
		  copy_f( b->left,a->left ) ;
		  copy_f( b->right,a->right ) ;
		  break ;
	 case 4 : b->left  = a->left ;
	 	  if (a->right == NULL)
			{
			 b->right = NULL ;
			}
			else
			{
			 aux2  = malloc(sizeof(function)) ;
			 b->right = aux2 ;
			 copy_f( b->right,a->right ) ;
			}
		  break ;
	 default  : ;
	}

}


double eval_f( function* f, double x )
{
 double l=0.0,r ;
 unsigned long t,tmp ;

 error_value = 0 ;
 t = f->type ;
 switch( t & CACHE )
 	{
	case 0 : return f->val ; break ; // constante
	case 1 : tmp = t >> SHIFT16 ; // variable
		 if ( tmp == 0 ) return x ;
			else
		 	{
			 error_value = 1 ;
			 return 0.0 ;
			}
		 break ;
	case 2 : l = eval_f( f->left,x ) ; // oprateur unitaire
		 if ( error_value ) return 0.0 ;
		 tmp = t >> SHIFT8 ;
		 switch(tmp)
			{
			case 0  : return (-l) ; break ;
			case 1  : return (l)  ; break ;
			case 2  : if (l >= 0 ) return (sqrt(l)) ;
					else
					{
					 error_value = 3 ;
					 return 0.0 ;
					}
				  break ;
			case 3  : return (l*l) ; break ;
			case 4  : return (fabs(l)) ; break ;
			case 5  : return (exp(l)) ; break ;
			case 6  : if (l >  0 ) return (log(l)) ;
					else
					{
					 error_value = 3 ;
					 return 0.0 ;
					}
				  break ;
			case 7  : if (l >  0 ) return (log10(l)) ;
					else
					{
					 error_value = 3 ;
					 return 0.0 ;
					}
				  break ;
			case 8  : return (sin(l)) ; break ;
			case 9  : return (cos(l)) ; break ;
			case 10 : r = cos(l) ; // tan
				  if ( r == 0.0 )
					{
					 error_value = 2 ;
					 return 0.0 ;
					}
					else
					{
					 return (sin(l)/r) ;
					}
				  break ;
			case 11 : if (l == -1.0 ) return (-HALF_PI) ; // arcsin
				  if (l ==  1.0 ) return ( HALF_PI) ;
				  if ((l > -1.0) && (l<1.0)) return ( atan(l/sqrt(1-l*l)) ) ;
				 	else
					{
					 error_value = 3 ;
					 return 0.0 ;
					}
			case 12 : if (l == -1.0 ) return PI ; // arccos
				  if (l ==  1.0 ) return 0.0 ;
				  if ((l > -1.0) && (l<1.0))
				  		return ( HALF_PI - atan(l/sqrt(1-l*l)) ) ;
				 	else
					{
					 error_value = 3 ;
					 return 0.0 ;
					}
			case 13 : return ( atan(l)) ; break ; // arctan
			case 14 : return ( floor(l+0.5) ) ; break ; // round
			case 15 : r = exp(l) ; return ( 0.5*(r-1.0/r)) ; break ; // sh
			case 16 : r = exp(l) ; return ( 0.5*(r+1.0/r)) ; break ; // ch
			case 17 : r = exp(2.0*l) ; return ( (r-1.0)/(r+1.0)) ; break ; // th
			case 18 : return ( log(l+sqrt(1.0+l*l)) ) ; break ; // argsh
			case 19 : if ( l >= 1.0 ) return (log(l+sqrt(l*l-1.0)) ) ; // argch
					else
					{
					 error_value = 3 ;
					 return 0.0 ;
					}
				  break ;
			case 20 : if (( l > -1.0 ) && ( l < 1.0 ))
					return ( 0.5*log((l+1.0)/(1.0-l)) ) ; // argth
					else
					{
					 error_value = 3 ;
					 return 0.0 ;
					}
			case 21 : return ( floor(l)) ; break ; // floor
			case 22 : return ( ceil(l)) ; break ; // ceil
			case 23 : l = fabs(l) ; r = 1.0 ; // factorial
				  while(l > 1.0 )
					{
					 r *= l ;
					 l -= 1.0 ;
					}
				  return (r) ;
				  break ;
			case 24 : return( l-floor(l) ) ; break ; // frac
			default : error_value = 4 ; return 0.0 ;
			}
		 break ;
	case 3 : l = eval_f( f->left,x ) ; // oprateur binaire
		 if ( error_value ) return 0.0 ;
		 r = eval_f( f->right,x ) ;
		 if ( error_value ) return 0.0 ;
		 tmp = t >> SHIFT4 ;
		 switch(tmp)
			{
			case 0 : return (l+r) ; break ;
			case 1 : return (l-r) ; break ;
			case 2 : return (r*l) ; break ;
			case 3 : if ( r == 0.0 )
					{
					 error_value = 2 ;
					 return 0.0 ;
					}
					else
					{
					 return (l/r) ;
					}
				 break ;
			 case 4 : if ( l>0) return (pow(l,r)) ;
			 		else
					{
					 if (l==0.0)
						{
						 if (r>0) return 0.0 ;
						 	else
							{
							 error_value = 3 ;
						 	 return 0.0 ;
							}
						}
					 if (r==floor(r))
						{
						 return (pow(l,r)) ;
						}
						else
						{
						 error_value = 3 ;
						 return 0.0 ;
						}
					}
				  break ;
			 default : error_value = 5 ; return 0.0 ;
			}
		 break ;
	case 4 : if (((t >> SHIFT20)==5) || ((t >> SHIFT25)>0))
			{
			 r = eval_f( f->right,x ) ;
			 if ( error_value ) return 0.0 ;
			 l = eval_f( f->left,r ) ;
			 if ( error_value ) return 0.0 ; else return l  ;
			}
			else
			{
			 l = eval_f( f->left,x ) ;
			 if ( error_value ) return 0.0 ; else return l ;
			}
			//{
			// if ((t >> SHIFT25) < MAX_FUNCTIONS) l = eval_f( f->left,x ) ; // constantes ou fonctions
			//	else l = f->val ; // c'est l'ancien ans.
			// if ( error_value ) return 0.0 ; else return l ;
			//}
		 break ;
	default : error_value = 6 ; return 0.0 ;
	}
}


int search_parenthesis( long* i,long direction,char* ch,unsigned long len )
{
 long np=0 ;

 do
 {
  if (ch[*i] == '(') np++ ;
  if (ch[*i] == ')') np-- ;
  (*i) += direction ;
 }
 while ((np != 0) && (*i<=len) && (*i>=0)) ;

 (*i) -= direction ;

 return (np==0) ;
}

int create_tree(char* string, unsigned long len, function* f )
{
 long i,v ;
 size_t l2 ;
 char ctemp ;
 function* pf1 ;
 function* pf2 ;


// printf("\n@") ;
// for(i=0;i<len;i++) printf("%c" , string[i]) ;
// printf("@") ;
// printf("\n-> %lu" , f->type ) ;
// printf("\n@") ;

 if ( len == 0 ) return 100 ;
 //-------- 1 : Recherche de + , - , * , / binaires
 i = len-1 ;
 do
 {
  if (( string[i] == ')' ) && (! search_parenthesis( &i,-1,string,len ) ))
  	return 101 ;
 i-- ;
  if ( string[i] == '+' )
	{
	 if ((i>0) && (i<len-1) &&
	    ((ctemp=string[i-1]) != '(') &&
	    (ctemp != 'e') &&
	    (ctemp != '*') &&
	    (ctemp != '/') &&
	    (ctemp != '^'))
		{
		 f->type = 3 ; // + binaire
		 pf1 = (function*) malloc(sizeof(function)) ;
		 pf2 = (function*) malloc(sizeof(function)) ;
		 initialise_f( pf1 ) ;
		 initialise_f( pf2 ) ;
		 f->left = pf1 ;
		 f->right = pf2 ;
		 if (create_tree( string,i,f->left ))
		 	return 200 ;
		 if (create_tree( string+(i+1),len-i-1,f->right ))
		 	return 300 ;
		 return 0 ;
		}
	}
  if ( string[i] == '-' )
	{
	 if ((i>0) && (i<len-1) &&
	    ((ctemp=string[i-1]) != '(') &&
	    (ctemp != 'e') &&
	    (ctemp != '*') &&
	    (ctemp != '/') &&
	    (ctemp != '^'))
		{
		 f->type = (1 << SHIFT4) + 3 ; // + binaire
		 pf1 = (function*) malloc(sizeof(function)) ;
		 pf2 = (function*) malloc(sizeof(function)) ;
		 initialise_f( pf1 ) ;
		 initialise_f( pf2 ) ;
		 f->left = pf1 ;
		 f->right = pf2 ;
		 if (create_tree( string,i,f->left ))
		 	return 400 ;
		 if (create_tree( string+(i+1),len-i-1,f->right ))
		 	return 500 ;
		 return 0 ;
		}
	}
 // i-- ;
 }
 while ( i>0 ) ;

 i = len-1 ;
 do
 {
  if (( string[i] == ')' ) && (! search_parenthesis( &i,-1,string,len ) ))
  	return 501 ;
 i-- ;
  if ( string[i] == '*' )
	{
	 if ((i>0) && (i<len-1))
		{
		 f->type = (2 << SHIFT4) + 3 ; // * binaire
		 pf1 = (function*) malloc(sizeof(function)) ;
		 pf2 = (function*) malloc(sizeof(function)) ;
		 initialise_f( pf1 ) ;
		 initialise_f( pf2 ) ;
		 f->left = pf1 ;
		 f->right = pf2 ;
		 if (create_tree( string,i,f->left ))
		 	return 600 ;
		 if (create_tree( string+(i+1),len-i-1,f->right ))
		 	return 700 ;
		 return 0 ;
		}
	}
  if ( string[i] == '/' )
	{
	 if ((i>0) && (i<len-1))
		{
		 f->type = (3 << SHIFT4) + 3 ; // / binaire
		 pf1 = (function*) malloc(sizeof(function)) ;
		 pf2 = (function*) malloc(sizeof(function)) ;
		 initialise_f( pf1 ) ;
		 initialise_f( pf2 ) ;
		 f->left = pf1 ;
		 f->right = pf2 ;
		 if (create_tree( string,i,f->left ))
		 	return 800 ;
		 if (create_tree( string+(i+1),len-i-1,f->right ))
		 	return 900 ;
		 return 0 ;
		}
	}
 }
 while ( i>0 ) ;

 //-------- 2 : Recherche de + et - unaires
 if ( string[0] == '+' )
	{
	 f->type = (1 << SHIFT8) + 2 ;
	 pf1 = (function*) malloc(sizeof(function)) ;
	 initialise_f( pf1 ) ;
	 f->left = pf1 ;
	 f->right = NULL ;
	 if (create_tree( string+1,len-1,f->left ))
	 	return 1000 ;
	 return 0 ;
	}
 if ( string[0] == '-' )
	{
	 f->type = (0 << SHIFT8) + 2 ;
	 pf1 = (function*) malloc(sizeof(function)) ;
	 initialise_f( pf1 ) ;
	 f->left = pf1 ;
	 f->right = NULL ;
	 if (create_tree( string+1,len-1,f->left ))
	 	return 1100 ;
	 return 0 ;
	}
 //-------- 3 : Recherche de ^
 i = len-1 ;
 do
 {
  if (( string[i] == ')' ) && (! search_parenthesis( &i,-1,string,len ) ))
  	return 1200 ;
   i-- ;
  if ( string[i] == '^' )
	{
	 if ((i>0) && (i<len-1))
		{
		 f->type = (4 << SHIFT4) + 3 ; // ^ binaire
		 pf1 = (function*) malloc(sizeof(function)) ;
		 pf2 = (function*) malloc(sizeof(function)) ;
		 initialise_f( pf1 ) ;
		 initialise_f( pf2 ) ;
		 f->left = pf1 ;
		 f->right = pf2 ;
		 if (create_tree( string,i,f->left ))
		 	return 1300 ;
		 if (create_tree( string+(i+1),len-i-1,f->right ))
		 	return 1400 ;
		 return 0 ;
		}
	}
 }
 while ( i>0 ) ;
 //-------- 4 : Recherche des parentheses
 i = 0 ;
 if (string[0] =='(')
	{
	 if (search_parenthesis( &i,1,string,len ) && (i == len-1))
	 	return create_tree( string+1,len-2,f ) ;
	 return 0 ;
	}
 //-------- 5 : Recherche des factoriels
 if (string[len-1] =='!')
	{
	 f->type = (23 << SHIFT8) + 2 ;
	 pf1 = (function*) malloc(sizeof(function)) ;
	 initialise_f( pf1 ) ;
	 f->left = pf1 ;
	 f->right = NULL ;
	 return create_tree( string,len-1,f->left ) ;
	}
 //-------- 6 : Recherche des fonctions lmentaires
 for(i=0;i<25;i++)
	{
	 l2 = strlen(opUnaires[i]) ;
	 if ((strncmp(string,opUnaires[i],l2)==0) && (string[l2]=='('))
		{
		 f->type = (i << SHIFT8) + 2 ;
		 pf1 = (function*) malloc(sizeof(function)) ;
		 initialise_f( pf1 ) ;
		 f->left = pf1 ;
		 f->right = NULL ;
		 return create_tree( string+l2,len-l2,f->left ) ;
		}
	}


 //-------- 7 : Recherche des inconnues
 if ( string[0] == 'x' )
	{
	 f->type = (0 << SHIFT16) + 1 ;
	 f->left = NULL ;
	 f->right = NULL ;
	 return 0 ;
	}
 //-------- 8 : Recherche des constantes prdfinies
 if ((string[0]=='p') && (string[1]=='i'))
	{
	 f->type = 0 ;
	 f->val = PI ;
	 f->left = NULL ;
	 f->right = NULL ;
	 return 0 ;
	}
 if ((string[0]=='e') && (string[1]=='e'))
	{
	 f->type = 0 ;
	 f->val = E ;
	 f->left = NULL ;
	 f->right = NULL ;
	 return 0 ;
	}
 if ((string[0]=='e') && (string[1]=='u'))
	{
	 f->type = 0 ;
	 f->val = EU ;
	 f->left = NULL ;
	 f->right = NULL ;
	 return 0 ;
	}
 //-------- 9 : Recherche des fonctions auxiliaires ou de constantes
 ctemp = string[0] ;
 if ((len==1) && (ctemp>='a') && (ctemp<='z') && (ctemp!='f'))
	{
	 v = ctemp-'a' ;
	 f->type = (v << SHIFT20) + 4 ;
	 f->left = &lpre[v] ;
	 f->right = NULL ;
	 return 0 ;
	}

 if (ctemp=='f')
	{
	 if (string[1]=='(')
		{
		 //v = ctemp-'a' ;
		 f->type = (5 << SHIFT20) + 4 ;//f->type = (v << SHIFT20) + 4 ;
		 f->left = &lpre[5] ;//f->left = &lpre[v] ;
		 pf1 = (function*) malloc(sizeof(function)) ;
		 initialise_f( pf1 ) ;
		 f->right = pf1 ;
		 return create_tree( string+1,len-1,f->right ) ;
		}
	 if (string[2]=='(')
		{
		 v = str2ld(string+1,1,&i) ;
		 if ((i==1) || (v==0)) return 1500 ;
		 f->type = (v << SHIFT25) + 4 ;
		 f->left = &fpre[v-1] ;
		 pf1 = (function*) malloc(sizeof(function)) ;
		 initialise_f( pf1 ) ;
		 f->right = pf1 ;
		 return create_tree( string+2,len-2,f->right ) ;
		}
	 if (string[3]=='(')
		{
		 v = str2ld(string+1,2,&i) ;
		 if ((i==1) || (v<10) || (v>MAX_FUNCTIONS)) return 1501 ;
		 f->type = (v << SHIFT25) + 4 ;
		 f->left = &fpre[v-1] ;
		 pf1 = (function*) malloc(sizeof(function)) ;
		 initialise_f( pf1 ) ;
		 f->right = pf1 ;
		 return create_tree( string+3,len-4,f->right ) ;
		}
	 return 1502 ;
	}

 if ((ctemp=='') || (strncmp(string,"ans",3)==0) || (strncmp(string,"ANS",3)==0))
	{
	 f->type = 0 ;//f->type = ((MAX_FUNCTIONS) << SHIFT25) + 4 ;
	 f->val = old_ans ;
	 f->left = NULL ;
	 f->right = NULL ;
	 return 0 ;
	}

 //-------- 10 : Recherche des valeurs numriques
 f->type = 0 ;
 f->val = str2lf(string,len,&i) ;
 f->left = NULL ;
 f->right = NULL ;
 if (i==1) return 1600 ;
 	else return 0 ;
}

int create_f( char* string, function* f )
{
 long len ;

 //cut_space( string ) ;
 len = strlen( string ) ;
 return create_tree( string,len,f ) ;
}











