/*
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include <string.h>


#include "func.h"
extern function lpre[] ;
extern function fpre[] ;
extern double old_ans ;
extern int error_value ;

//#include "func.h"


#define MAX_STRING 256
static char FIN[]  = "quit" ;
static char FIN2[] = "end" ;

void cut_space( char* string )
{
 long i,j,len ;
 char st[MAX_STRING] ;
 char c ;

 len = (long) strlen( string ) ;
 j = 0 ;
 for(i=0;i<len;i++)
	{
	 if (((c=string[i]) != ' ') && (c != '\t') && (c!='\n'))
		{
		 st[j] = c ;
		 j++ ;
		}
	}
 if (j <= MAX_STRING-1) st[j] = '\0' ; else st[MAX_STRING-1] = '\0' ;
 strcpy( string,st ) ;
}

long search_egal( char* st )
{
 long i,len ;

 len = strlen( st ) ;
 for(i=0;i<len;i++) if (st[i] == '=') return i ;
 return -1 ;
}


int main( int argc , char * argv[] )
{
 char stringANS[MAX_STRING] ;
 double res=0.0,x=0.0 ;
 long pos,p,j,err_x ;
 size_t len ;
 function ans ;
 int success_creation ;

 initialise_f( &ans) ;

 if (argc == 2)
	{
	 strcpy(stringANS,argv[1]) ;
	 stringANS[MAX_STRING-1] = '\0' ;
	 cut_space( stringANS ) ;
	 len = strlen( stringANS ) ;
	 if (len == 0 ) return 0 ;
	 success_creation = create_tree( stringANS ,len,&ans ) ;
	 if (success_creation)
		{
		 printf("\n\t\t\tIncorrect syntax (ERROR : %i)" , success_creation ) ;
		}
		else
		{
		 res = eval_f( &ans,x ) ;
		 if (error_value == 0 )
			{
			 printf("\n\t\t\t%5.15lf" , res ) ;
			}
			else
			{
			 printf("\n\t\t\tERROR %i" , error_value ) ;
			}
		}
	 destroy_f( &ans ) ;
	 printf("\n") ;
	 return 0 ;
	}

 do
 {
  printf("\n > ") ;
  fgets( stringANS,MAX_STRING-1,stdin ) ;
  cut_space( stringANS ) ;
  len = strlen( stringANS ) ;
  if (len == 0 )
	{
	 printf("\t\t\t%5.15lf" , old_ans ) ;
	 continue ;
	}
  if ((strcmp(stringANS,FIN)==0) || (strcmp(stringANS,FIN2)==0)) break ;
  pos = search_egal( stringANS ) ;

  if ( pos == -1 )
	{
	 // c'est une simple expression ou une constante  afficher.
	 if ((strcmp(stringANS,"ANS")==0) || (strcmp(stringANS,"ans")==0)  || ((stringANS[0] == '')&&(len==1)) )
		{
		 //print_f( &ans ) ;
		 if (ans.type == DEFAULT_TYPE)
			{
			 printf("\t\t\tNOT ANS.") ;
			}
			else
			{
			 res = eval_f( &ans,x ) ;
			 if (error_value == 0)
				{
				 old_ans = res ;
				 printf("\t\t\t%5.15lf" , res ) ;
				}
				else
				{
				 printf("\t\t\tERROR %i" , error_value ) ;
				}
			}
		 continue ;
		}
	 if ((len == 1) && (stringANS[0] >= 'a') && (stringANS[0] <= 'z') && (stringANS[0] != 'f'))
		{
		 p = stringANS[0] - 'a' ;
		 if (lpre[p].type == DEFAULT_TYPE)
			{
			 printf("\t\t\tTHE MEMORY IS NOT.") ;
			}
			else
			{
			 if (verifyLoop( &lpre[p],&lpre[p] )>0)
				{
				 printf("\t\t\tINFINITE RECURSIVE LOOP.") ;
				}
				else
				{
				 res = eval_f( &lpre[p],x ) ;
				 old_ans = res ;
				 if (error_value == 0 )
					{
					 printf("\t\t\t%5.15lf" , res ) ;
					}
					else
					{
					 printf("\t\t\tERROR %i" , error_value ) ;
					}
				}
			}
		 continue ;
		}


	 destroy_f( &ans ) ;
	 //printf("\n$%s$", stringANS ) ;
	 success_creation = create_f( stringANS , &ans ) ;
	 //printf("\n-------") ;
	 if (success_creation)
		{
		 //printf("\n\t\t\tIncorrect syntax   (ERROR : %i)" , success_creation ) ;
		 destroy_f( &ans ) ;
		}
		else
		{
		 res = eval_f( &ans,x ) ;
		 old_ans = res ;
		 if (error_value == 0 )
			{
			 printf("\t\t\t%5.15lf" , res ) ;
			}
			else
			{
			 printf("\t\t\tERROR %i" , error_value ) ;
			}
		}
	}
	else
	{
	 // c'est une dfinition de fonction.
	 if (pos == 0 )
		{
		 printf("\t\t\tIncorrect syntax" ) ;
		 continue ;
		}
	 if (pos == 1 )
		{
		 if ((stringANS[0] >= 'a') && (stringANS[0] <= 'z') && (stringANS[0] != 'f') )
			{
			 p = stringANS[0] - 'a' ;
			 destroy_f( &lpre[p] ) ;
			 success_creation = create_f( stringANS+2 , &lpre[p] ) ;

			 if (success_creation)
				{
				 printf("\t\t\tIncorrect syntax (ERROR : %i)" , success_creation ) ;
				 destroy_f( &lpre[p] ) ;
				}
				else
				{
				 if (verifyLoop( &lpre[p],&lpre[p] )>0)
					{
					 printf("\t\t\tINFINITE RECURSIVE LOOP.") ;
					}
					else
					{
					 res = eval_f( &lpre[p],x ) ;
					 old_ans = res ;
					 if (error_value == 0 )
						{
						 printf("\t\t\t%5.15lf" , res ) ;
						}
						else
						{
						 printf("\t\t\tERROR %i" , error_value ) ;
						}
					}

				}

			}
			else
			{
			 printf("\t\t\tIncorrect syntax : you must use LOWER letter !" ) ;
			}
		 continue ;
		}
	 if ((pos == 4 ) && (strncmp(stringANS,"f(x)",4)==0))
		{
		 destroy_f( &lpre[5] ) ; // 5 <-> f
		 success_creation = create_f( stringANS+5 , &lpre[5] ) ;
		 if (success_creation)
			{
			 printf("\t\t\tIncorrect syntax (ERROR : %i)" , success_creation ) ;
			 destroy_f( &lpre[5] ) ;
			}
		 continue ;
		}
	 if (pos == 5 )
		{
		 j = str2ld( stringANS+1,1,&err_x ) ;
		 if ((j<1) || (j>9) || (err_x==1) || (stringANS[0] != 'f') ||
		     (stringANS[2] != '(') || (stringANS[4] != ')') || (stringANS[3] != 'x'))
			{
			 printf("\t\t\tIncorrect syntax " ) ;
			}
			else
			{
			 destroy_f( &fpre[j-1] ) ;
			 success_creation = create_f( stringANS+6 , &fpre[j-1] ) ;
			 if (success_creation)
				{
				 printf("\t\t\tIncorrect syntax (ERROR : %i)" , success_creation ) ;
				 destroy_f( &fpre[j-1] ) ;
				}
			 continue ;
			}

		}
	 if (pos == 6 )
		{
		 j = str2ld( stringANS+1,2,&err_x ) ;
		 if ((j<10) || (j>MAX_FUNCTIONS) || (err_x==1) || (stringANS[0] != 'f') ||
		     (stringANS[3] != '(') || (stringANS[5] != ')') || (stringANS[4] != 'x'))
			{
			 printf("\t\t\tIncorrect syntax " ) ;
			}
			else
			{
			 destroy_f( &fpre[j-1] ) ;
			 success_creation = create_f( stringANS+7 , &fpre[j-1] ) ;
			 if (success_creation)
				{
				 printf("\t\t\tIncorrect syntax (ERROR : %i)" , success_creation ) ;
				 destroy_f( &fpre[j-1] ) ;
				}
			 continue ;
			}

		}
	 if (pos>6) printf("\t\t\tIncorrect syntax " ) ;
	}

 }
 while(1) ;



 destroy_f( &ans ) ;
 for(j=0;j<MAX_FUNCTIONS_ALPHABET;j++) destroy_f( &lpre[j] ) ;
 for(j=0;j<MAX_FUNCTIONS;j++) destroy_f( &fpre[j] ) ;


 return 0 ;
}

